'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _CloudUpload = require('@material-ui/icons/CloudUpload');

var _CloudUpload2 = _interopRequireDefault(_CloudUpload);

var _Error = require('@material-ui/icons/Error');

var _Error2 = _interopRequireDefault(_Error);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NO_FILE_ERROR_CODE = 1;
var BAD_EXTENSION_ERROR_CODE = 2;
var TOO_BIG_ERROR_CODE = 3;
var UPLOADING_ERROR_CODE = 4;

var ImageUpload = function (_Component) {
  _inherits(ImageUpload, _Component);

  function ImageUpload() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ImageUpload);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ImageUpload.__proto__ || Object.getPrototypeOf(ImageUpload)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isUploading: false,
      hasError: false,
      errorText: '',
      progress: 0
    }, _this.hasExtension = function (fileName) {
      var patternPart = _this.props.allowedExtensions ? _this.props.allowedExtensions.map(function (a) {
        return a.toLowerCase();
      }).join('|') : '';
      var pattern = '(' + patternPart.replace(/\./g, '\\.') + ')$';
      return new RegExp(pattern, 'i').test(fileName.toLowerCase());
    }, _this.handleError = function (errorCode) {
      var errorText = '';
      switch (errorCode) {
        case NO_FILE_ERROR_CODE:
          errorText = 'No file selected';
          break;
        case BAD_EXTENSION_ERROR_CODE:
          errorText = 'Bad file type';
          break;
        case TOO_BIG_ERROR_CODE:
          errorText = 'Too big';
          break;
        case UPLOADING_ERROR_CODE:
          errorText = 'Error while uploading';
          break;
        default:
          errorText = 'Unknown error';
          break;
      }
      // Need to flick "isUploading" because otherwise the handler doesn't fire properly
      _this.setState({ hasError: true, errorText: errorText, isUploading: true }, function () {
        return _this.setState({ isUploading: false });
      });
      setTimeout(function () {
        return _this.setState({ hasError: false, errorText: '' });
      }, 5000);
    }, _this.handleFileSelected = function (e) {
      if (!e.target.files || !e.target.files[0]) {
        _this.handleError(NO_FILE_ERROR_CODE);
        return;
      }
      var file = e.target.files[0];
      if (!_this.hasExtension(file.name)) {
        _this.handleError(BAD_EXTENSION_ERROR_CODE);
        return;
      }
      if (file.size > _this.props.maxFileSize) {
        _this.handleError(TOO_BIG_ERROR_CODE);
        return;
      }
      if (_this.props.imageLoaded) {
        _this.readFile(file).then(function (data) {
          return _this.props.imageLoaded(data);
        });
      }
      if (_this.props.imageUpload) {
        _this.setState({ isUploading: true });
        _this.props.imageUpload(file, _this.handleReportProgress).then(function (resp) {
          _this.setState({ progress: undefined, isUploading: false });
          _this.props.imageUploaded && _this.props.imageUploaded(resp);
        }).catch(function (error) {
          _this.setState({ isUploading: false });
          _this.props.imageUploadError && _this.props.imageUploadError(error);
        });
      }
    }, _this.handleFileUploadClick = function (e) {
      return _this.fileInput.click();
    }, _this.handleReportProgress = function (progress) {
      return _this.setState({ progress: progress });
    }, _this.renderChildren = function () {
      if (_this.state.isUploading) {
        return _react2.default.createElement(_CircularProgress2.default, { value: _this.state.progress, size: 19 });
      }
      if (_this.state.hasError) {
        return _react2.default.createElement(
          _react2.default.Fragment,
          null,
          _this.state.errorText,
          _react2.default.createElement(_Error2.default, { size: 19, style: { marginLeft: '8px' } })
        );
      }
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _this.props.buttonContent,
        _this.props.icon
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ImageUpload, [{
    key: 'readFile',
    value: function readFile(file) {
      return new Promise(function (resolve, reject) {
        var reader = new FileReader();

        // Read the image via FileReader API and save image result in state.
        reader.onload = function (e) {
          // Add the file name to the data URL
          var dataUrl = e.target.result;
          dataUrl = dataUrl.replace(';base64', ';name=' + file.name + ';base64');
          resolve({ file: file, dataUrl: dataUrl });
        };

        reader.readAsDataURL(file);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _Button2.default,
          {
            disabled: this.state.isUploading,
            variant: 'contained',
            color: this.state.hasError ? 'secondary' : 'primary',
            onClick: this.handleFileUploadClick,
            style: Object.assign({}, this.props.style)
          },
          this.renderChildren()
        ),
        !this.state.isUploading && _react2.default.createElement('input', {
          style: { display: 'none' },
          ref: function ref(fileInput) {
            return _this2.fileInput = fileInput;
          },
          type: 'file',
          onChange: this.handleFileSelected
        })
      );
    }
  }]);

  return ImageUpload;
}(_react.Component);

ImageUpload.defaultProps = {
  buttonContent: 'Upload image',
  icon: _react2.default.createElement(_CloudUpload2.default, { style: { marginLeft: '8px' } }),
  allowedExtensions: ['jpg', 'jpeg', 'png'],
  maxFileSize: 5242880
};
exports.default = ImageUpload;
//# sourceMappingURL=index.js.map